Public Class frmBacteriaList


    Public fBacteriaCollect As Collection
    Private fMode As GenDec.FormMode

    Private fDNALookIn As String = ""


    Private fcLastColSorted As Integer = -1


#Region " Form Events "


    Private Sub frmList_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        UFS.FormLoad(Me, GenDec.INIFileName, , 1)

        'frmNewMain.Refresh()
        'Application.DoEvents()


        'FormSaber.FL(Me)

        Me.FormLoad()



    End Sub

    Private Sub frmList_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        UFS.FormSave(Me, GenDec.INIFileName, , 1)

        'FormSaber.FS(Me)

    End Sub

    Private Sub frmList_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        'Me.lvwList.Width = Me.Width - Me.lvwList.Left - Me.lvwList.Left
        'Me.lvwList.Height = Me.Height - 100


    End Sub


#End Region


#Region " List View Support "


    Private Sub LVWLoadItem(ByRef rBacteria As Bacteria, Optional ByVal vIndex As Integer = -1, Optional ByVal vSelect As Byte = 0, Optional ByVal vRemItem As Byte = 0)

        Dim tItem As New ListViewItem

        tItem.Tag = rBacteria

        tItem.SubItems(0).Text = rBacteria.FullName
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, String.Format(GenDec.cFormatDate, rBacteria.RecDate)))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.FormerName))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.Donor))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.HostStrain))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.Markers))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.PlasmidSize))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.ParentVector))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.InsertOf))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rBacteria.Comments))

        GenDec.LVWItemPlace(Me.lvwList, tItem, vIndex, vSelect, vRemItem)


    End Sub


    Private Sub lvwList_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvwList.ColumnClick

        Dim lvwColumnSorter As New LVWColSorter(Me.lvwList, e.Column)


        ' Set the column number that is to be sorted; default to ascending.
        If Me.lvwList.Sorting = SortOrder.Ascending Then
            'Was Ascending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Descending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Descending

        Else
            'Was Descending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Ascending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Ascending

        End If

        Me.lvwList.ListViewItemSorter = lvwColumnSorter

        ' Perform the sort with these new sort options.
        'Me.lvwList.Sort()


        If Me.lvwList.SelectedItems.Count > 0 Then
            Call Me.lvwList.SelectedItems(0).EnsureVisible()
        End If
    End Sub

    Private Sub lvwList_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvwList.MouseDoubleClick

        Call mnuEdit_Click(Nothing, Nothing)

    End Sub


#End Region



    Public Sub paDialog(ByRef rCollect As Collection, ByVal vMode As GenDec.FormMode, Optional ByVal vDNA As String = "")

        Me.fBacteriaCollect = rCollect
        Me.fMode = vMode


        Me.fDNALookIn = vDNA

        Me.Show()


    End Sub


#Region "Menu Support "

    Private Sub mnuEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionEdit.Click

        Me.mnuTSEdit_Click(Nothing, Nothing)

    End Sub


    Private Sub mnuPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionPrint.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim PrintStr As String

        Dim tBacteria As Bacteria = CType(Me.lvwList.SelectedItems(0).Tag, Bacteria)

        With tBacteria

            PrintStr = .FullName & vbCrLf & "RecDate: " & .RecDate & vbCrLf
            PrintStr = PrintStr & "Former Name: " & .FormerName & vbCrLf
            PrintStr = PrintStr & "Donor: " & .Donor & vbCrLf
            
            PrintStr = PrintStr & "Host Strain: " & .HostStrain & vbCrLf
            PrintStr = PrintStr & "Plasmid Size: " & .PlasmidSize & vbCrLf
            PrintStr = PrintStr & "Markers: " & .Markers & vbCrLf
            PrintStr = PrintStr & "Insert: " & .InsertOf & vbCrLf
            PrintStr = PrintStr & "Parent Vector: " & .ParentVector & vbCrLf

            PrintStr = PrintStr & "Comments: " & vbCrLf & .Comments & vbCrLf

            If .CustomField1 <> "" Then
                PrintStr = PrintStr & frmNewMain.BacteriaCustomField1 & ":" & .CustomField1 & vbCrLf
            End If

            If .CustomField2 <> "" Then
                PrintStr = PrintStr & frmNewMain.BacteriaCustomField2 & ":" & .CustomField2 & vbCrLf
            End If



        End With

        'dim Blah as Ne
        Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        Blah.Write(PrintStr)


        Blah.Close()

        Process.Start(Application.StartupPath & "\Print.txt")


    End Sub


    Private Sub mnuMainFullList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMainFullList.Click

        Me.fMode = GenDec.FormMode.ModeA

        Me.FormLoad()


    End Sub

    Private Sub mnuAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchToolStripMenuItem1.Click

        Dim Blah As New frmSearch
        Dim Bac As New Bacteria


        If Blah.paDialog(Bac, Me.fBacteriaCollect) = Windows.Forms.DialogResult.OK Then


            Me.fMode = GenDec.FormMode.ModeB

            Me.FormLoad()

        End If



    End Sub


    Private Sub mnuActionFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionFind.Click

        Dim Blah As New frmLVWFind

        Blah.paShow(Me, Me.lvwList)


    End Sub



    Private Sub mnuActionAdd_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionAdd.Click

        Me.mnuTSAdd_Click(Nothing, Nothing)


    End Sub

    Private Sub mnuDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuDelete.Click

        Dim tBacteria As Bacteria

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub

        tBacteria = CType(Me.lvwList.SelectedItems(0).Tag, Bacteria)

        If MessageBox.Show("Are you sure you want do delete " & tBacteria.FullName & "?", My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
            Bacteria.DBDelete(frmNewMain.Conn, tBacteria.BacteriaID)
            Me.lvwList.SelectedItems(0).Remove()
        End If

    End Sub



#End Region


    Private Sub btnDone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Me.Close()

    End Sub


    Private Sub FullList()

        Me.lvwList.Items.Clear()
        Me.Text = "Full List"

        For Each tBacteria As Bacteria In Bacteria.DBBacterias(frmNewMain.Conn)
            fBacteriaCollect.Add(tBacteria)
        Next


    End Sub


    Private Sub FormLoad()

        Me.lvwList.Items.Clear()


        Select Case fMode

            Case GenDec.FormMode.ModeA
               
                fBacteriaCollect.Clear()

                For Each tBacteria As Bacteria In Bacteria.DBBacterias(frmNewMain.Conn)
                    fBacteriaCollect.Add(tBacteria)
                Next
                Me.Text = "Bacteria Complete List (" & fBacteriaCollect.Count & ")"


            Case GenDec.FormMode.ModeB
                Me.Text = "Bacteria Search Results (" & fBacteriaCollect.Count & " Rows" & ")"

            Case Else
                Throw New Exception("No Mode for form")

        End Select


        For Each tBacteria As Bacteria In fBacteriaCollect
            Me.LVWLoadItem(tBacteria)
        Next



        'Me.Text = "Search Results (" & fBacteriaCollect.Count & " Rows" & ")"

    End Sub


#Region " Menu Tool Strip "

    Private Sub mnuTSPrintList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSPrintList.Click

        ''Const cPadID As Integer = 5
        'Const cPadLabName As Integer = 10
        'Const cPadPurpose As Integer = 30
        'Dim tStr As String = "Full Name".PadRight(cPadLabName) & "Former Name".PadRight(cPadPurpose)
        'Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        'For Each tBacteria As Bacteria In Me.fBacteriaCollect

        '    tStr = tStr & vbCrLf & tBacteria.FullName.PadRight(cPadLabName) & tBacteria.FormerName.PadRight(cPadPurpose)

        'Next


        'Blah.Write(tStr)

        'Blah.Close()


        'Process.Start(Application.StartupPath & "\Print.txt")



        Dim tStr As String = ""
        Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        For Each tBact As Bacteria In Me.fBacteriaCollect

            With tBact
                tStr = tStr & .FullName & vbCrLf & String.Format(GenDec.cFormatDate, .RecDate) & vbCrLf & .FormerName & vbCrLf & .Donor & vbCrLf & vbCrLf
            End With


        Next


        Blah.Write(tStr)
        Blah.Close()

        Process.Start(Application.StartupPath & "\Print.txt")



    End Sub

    Private Sub mnuTSAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSAdd.Click

        Dim Blah As New frmBacteriaMaint

        Dim tBacteria As New Bacteria

        If Blah.paDialog(tBacteria) = Windows.Forms.DialogResult.OK Then
            'They Clicked Ok

            tBacteria.DBSave(frmNewMain.Conn)



            If Me.fMode <> GenDec.FormMode.ModeA Then
                'Got to show the complete list
                Me.fMode = GenDec.FormMode.ModeA
                Me.FormLoad()

                'need to select the right one. the list could all weird

                'try to highlight the one
                For Each titem As ListViewItem In Me.lvwList.Items
                    If CType(titem.Tag, Bacteria).BacteriaID = tBacteria.BacteriaID Then
                        titem.Selected = True
                        titem.EnsureVisible()
                        Exit For
                    End If
                Next

            Else
                'they are already in the mode so just add it
                Me.fBacteriaCollect.Add(tBacteria)

                Me.LVWLoadItem(tBacteria, , 1)

                Me.Text = "Bacteria Complete List (" & fBacteriaCollect.Count & ")"

            End If







        End If

    End Sub

    Private Sub mnuTSEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSEdit.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim Blah As New frmBacteriaMaint
        Dim tBacteria As Bacteria = CType(Me.lvwList.SelectedItems(0).Tag, Bacteria)

        If Blah.paDialog(tBacteria) = Windows.Forms.DialogResult.OK Then
            tBacteria.DBSave(frmNewMain.Conn)
            'Updating the list

            Me.LVWLoadItem(tBacteria, Me.lvwList.SelectedItems(0).Index, 1, 1)

        End If

    End Sub

#End Region


End Class