


Public Class frmOligoList


    Public fOligoCollect As Collection
    Private fMode As GenDec.FormMode

    Private fDNALookIn As String = ""


    Private fcLastColSorted As Integer = -1


    Public LastIndex As Int32 = -1 'The last index
    Public LastCol As Int32 = -1
    Public LastSearchValue As String = ""


#Region " Form Events "


    Private Sub frmList_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        UFS.FormLoad(Me, GenDec.INIFileName, , 1)

        'FormSaber.FL(Me)

        Me.FormLoad()



    End Sub

    Private Sub frmList_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        UFS.FormSave(Me, GenDec.INIFileName, , 1)

        'FormSaber.FS(Me)


    End Sub

    Private Sub frmList_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        Me.lvwList.Width = Me.Width - Me.lvwList.Left - Me.lvwList.Left
        Me.lvwList.Height = Me.Height - 100


    End Sub


#End Region


#Region " List View Support "


    Private Sub LVWLoadItem(ByRef rOligo As Oligo, Optional ByVal vIndex As Integer = -1, Optional ByVal vSelect As Byte = 0, Optional ByVal vRemItem As Byte = 0)

        Dim tItem As New ListViewItem

        tItem.Tag = rOligo

        tItem.SubItems(0).Text = rOligo.FullName
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, String.Format(GenDec.cFormatDate, rOligo.RecDate)))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.FormerName))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Donor))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Purpose))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Gene))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Speices))

        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Strand))

        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Supplier))

        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Tm))
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.Comments))

        If Me.fMode = GenDec.FormMode.ModeC Or fMode = GenDec.FormMode.ModeD Then
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.MatchCount))
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.MatchLongest))
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rOligo.MatchLongestIndex))
            'tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, Math.Round(DNA.BasicTm(rOligo.), 2)))
        End If


        GenDec.LVWItemPlace(Me.lvwList, tItem, vIndex, vSelect, vRemItem)


    End Sub


    Private Sub lvwList_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvwList.ColumnClick

        Dim lvwColumnSorter As New LVWColSorter(Me.lvwList, e.Column)


        ' Set the column number that is to be sorted; default to ascending.
        If Me.lvwList.Sorting = SortOrder.Ascending Then
            'Was Ascending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Descending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Descending

        Else
            'Was Descending
            lvwColumnSorter.SortColumn = e.Column
            lvwColumnSorter.Order = SortOrder.Ascending

            'Storing the sort order in the listview for later use
            Me.lvwList.Sorting = SortOrder.Ascending

        End If

        Me.lvwList.ListViewItemSorter = lvwColumnSorter

        ' Perform the sort with these new sort options.
        'Me.lvwList.Sort()


        If Me.lvwList.SelectedItems.Count > 0 Then
            Call Me.lvwList.SelectedItems(0).EnsureVisible()
        End If
    End Sub

    Private Sub lvwList_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvwList.MouseDoubleClick

        Call mnuEdit_Click(Nothing, Nothing)

    End Sub


#End Region



    Public Sub paDialog(ByRef rCollect As Collection, ByVal vMode As GenDec.FormMode, Optional ByVal vDNA As String = "")

        Me.fOligoCollect = rCollect
        Me.fMode = vMode

        If fMode = GenDec.FormMode.ModeC Then
            Me.mnuActionDNAView.Visible = True
        End If

        Me.fDNALookIn = vDNA

        Me.Show()


    End Sub


#Region "Menu Support "

    Private Sub mnuEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionEdit.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim Blah As New frmOligoMaint
        Dim tOligo As Oligo = CType(Me.lvwList.SelectedItems(0).Tag, Oligo)


        If Blah.paDialog(tOligo) = Windows.Forms.DialogResult.OK Then
            tOligo.DBSave(frmNewMain.Conn)
            'Updating the list

            Me.LVWLoadItem(tOligo, Me.lvwList.SelectedItems(0).Index, 1, 1)

        End If


    End Sub



    Private Sub mnuPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionPrint.Click

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim PrintStr As String

        Dim tOligo As Oligo = CType(Me.lvwList.SelectedItems(0).Tag, Oligo)

        With tOligo

            PrintStr = .FullName & vbCrLf & "RecDate: " & .RecDate & vbCrLf
            PrintStr = PrintStr & "Former Name: " & .FormerName & vbCrLf
            PrintStr = PrintStr & "Purpose: " & .Purpose & vbCrLf & "Sequence: " & vbCrLf
            PrintStr = PrintStr & .Sequnce & vbCrLf
            PrintStr = PrintStr & "Restriction: " & .RestrictionSite & vbCrLf & "Gene: " & .Gene & vbCrLf & "Species: " & .Speices & vbCrLf
            PrintStr = PrintStr & "Position Of: " & .Position & vbCrLf & "Strand: " & .Strand & vbCrLf & "Donor: " & .Donor & vbCrLf
            PrintStr = PrintStr & "Stock Conc: " & .StockConc & vbCrLf & "Supplier: " & .Supplier & vbCrLf
            PrintStr = PrintStr & "Comments: " & vbCrLf & .Comments & vbCrLf

            If .CustomField1 <> "" Then
                PrintStr = PrintStr & frmNewMain.OligoCustomField1 & ":" & .CustomField1 & vbCrLf
            End If

            If .CustomField2 <> "" Then
                PrintStr = PrintStr & frmNewMain.OligoCustomField2 & ":" & .CustomField2 & vbCrLf
            End If



        End With

        'dim Blah as Ne
        Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        Blah.Write(PrintStr)


        Blah.Close()

        Process.Start(Application.StartupPath & "\Print.txt")


    End Sub




#End Region


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Me.Close()

    End Sub



    Private Sub ViewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionDNAView.Click


        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        Dim tRec As Oligo = Me.lvwList.SelectedItems(0).Tag


        If Me.fMode = GenDec.FormMode.ModeC Then
            'Hybrid Search

            Dim Blah As New frmOligoDNACompare


            'Showing the particular dna sequence
            Blah.paDialog(Me.fDNALookIn, tRec, fMode)


        Else
            Dim PC As New frmOligoPCR


            'PC.paShow(tRec, Me.fDNALookIn)


        End If


    End Sub






    Private Sub FullList()

        Me.lvwList.Items.Clear()
        Me.Text = "Full List"

        For Each tOligo As Oligo In Oligo.DBOligos(frmNewMain.Conn)
            fOligoCollect.Add(tOligo)
        Next


    End Sub


    Private Sub SequenceSearchToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SequenceSearchToolStripMenuItem.Click


        Dim Blah As New frmOligoDNASearch

        If Blah.paDialog(Me.fOligoCollect, Me.fDNALookIn, GenDec.FormMode.ModeC) = Windows.Forms.DialogResult.OK Then

            'Flipping the mode
            Me.fMode = GenDec.FormMode.ModeC

            Me.FormLoad()

        End If



    End Sub


    Private Sub FormLoad()

        Me.lvwList.Items.Clear()


        Select Case fMode

            Case GenDec.FormMode.ModeA


                Me.mnuActionDNAView.Visible = False


                'Removing the two match columns at the end
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 1).Text = ""
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 2).Text = ""
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 3).Text = ""
                'Me.lvwList.Columns(Me.lvwList.Columns.Count - 4).Text = ""


                fOligoCollect.Clear()

                For Each tOligo As Oligo In Oligo.DBOligos(frmNewMain.Conn)
                    fOligoCollect.Add(tOligo)
                Next


                Me.Text = "Oligo Complete List (" & fOligoCollect.Count & " Rows" & ")"


            Case GenDec.FormMode.ModeB
                Me.Text = "Oligo Search Results (" & fOligoCollect.Count & " Rows" & ")"

                Me.mnuActionDNAView.Visible = False

                'Removing the two match columns at the end
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 1).Text = ""
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 2).Text = ""
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 3).Text = ""
                'Me.lvwList.Columns(Me.lvwList.Columns.Count - 4).Text = ""


            Case GenDec.FormMode.ModeC
                Me.Text = "Oligo DNA Binding Search Results (" & fOligoCollect.Count & " Rows" & ")"""


                Me.mnuActionDNAView.Visible = True
                Me.mnuActionDNAView.Text = "DNA Compare"

                Me.lvwList.Columns(Me.lvwList.Columns.Count - 3).Text = "# Matches"
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 2).Text = "Max Length"
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 1).Text = "Match Spot"
                'Me.lvwList.Columns(Me.lvwList.Columns.Count - 1).Text = "" '"Melt"

                For Each tOligo As Oligo In fOligoCollect

                    Dim tResults As Generic.IList(Of DNASearchResult)

                    tResults = DNA.DNACompleteSearch(fDNALookIn, tOligo.Sequnce)

                    'Going through determine the total match count for the oligo
                    For Each tM As DNASearchResult In tResults
                        tOligo.MatchCount += tM.MatchCount
                    Next

                    tOligo.MatchLongest = DNASearchResult.GetLongest(tResults)

                    tOligo.MatchLongestIndex = DNASearchResult.LongestMatchPositions(tResults)



                Next

            Case GenDec.FormMode.ModeD
                'PCR Binding search

                Me.Text = "Oligo DNA PCR Search Results (" & fOligoCollect.Count & " Rows" & ")"""


                Me.mnuActionDNAView.Visible = True
                Me.mnuActionDNAView.Text = "PCR Compare"

                Me.lvwList.Columns(Me.lvwList.Columns.Count - 3).Text = "# Matches"
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 2).Text = "Max Length"
                Me.lvwList.Columns(Me.lvwList.Columns.Count - 1).Text = "Match Spot"


                For Each tP As Oligo In Me.fOligoCollect
                    Dim PCRResults As Generic.List(Of DNASearchResult)

                    PCRResults = DNA.PCRSearch(fDNALookIn, tP.Sequnce, "PCR", DNA.cMinMatchLength)

                    tP.MatchLongest = DNASearchResult.GetLongest(PCRResults)
                    'The results are stacked nicely
                    tP.MatchCount = PCRResults.Count

                Next




            Case Else
                Throw New Exception("No Mode for form")

        End Select


        For Each tOligo As Oligo In fOligoCollect
            Me.LVWLoadItem(tOligo)
        Next



        'Me.Text = "Oligo Search Results (" & fOligoCollect.Count & " Rows" & ")"

    End Sub

    Private Sub mnuMainFullList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMainFullList.Click

        Me.fMode = GenDec.FormMode.ModeA

        Me.FormLoad()


    End Sub

    Private Sub SearchToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchToolStripMenuItem1.Click

        Dim Blah As New frmSearch
        Dim Ol As New Oligo


        If Blah.paDialog(Ol, Me.fOligoCollect) = Windows.Forms.DialogResult.OK Then


            Me.fMode = GenDec.FormMode.ModeB

            Me.FormLoad()

        End If



    End Sub

    Private Sub mnuActionDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)




    End Sub



    Private Sub mnuActionFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionFind.Click

        Dim Blah As New frmLVWFind

        Blah.paShow(Me, Me.lvwList)


    End Sub

    Private Sub mnuPrintList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPrintList.Click

        'Const cPadID As Integer = 5
        'Const cPadLabName As Integer = 10
        'Const cPadPurpose As Integer = 30
        'Dim tStr As String = "ID".PadRight(cPadID) & "Lab Name".PadRight(cPadLabName) & "Purpose".PadRight(cPadPurpose)
        'Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        'For Each tOligo As Oligo In Me.fOligoCollect

        '    tStr = tStr & vbCrLf & tOligo.OligoID.ToString.PadRight(cPadID) & tOligo.LabName.PadRight(cPadLabName) & tOligo.Purpose.PadRight(cPadPurpose)

        'Next


        Dim tStr As String = ""
        Dim Blah As IO.StreamWriter = IO.File.CreateText(Application.StartupPath & "\Print.txt")


        For Each tOligo As Oligo In Me.fOligoCollect

            With tOligo
                tStr = tStr & .FullName & vbCrLf & String.Format(GenDec.cFormatDate, .RecDate) & vbCrLf & .FormerName & vbCrLf & .Donor & vbCrLf & vbCrLf
            End With


        Next


        Blah.Write(tStr)
        Blah.Close()

        Process.Start(Application.StartupPath & "\Print.txt")


    End Sub

    Private Sub mnuActionAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuActionAdd.Click

        Dim Blah As New frmOligoMaint

        Dim tOligo As New Oligo

        If Blah.paDialog(tOligo) = Windows.Forms.DialogResult.OK Then
            'They Clicked Ok

            Me.fMode = GenDec.FormMode.ModeA
            Me.FormLoad()

            tOligo.DBSave(frmNewMain.Conn)

            Me.LVWLoadItem(tOligo, , 1)

        End If

    End Sub


    Private Sub DeleteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteToolStripMenuItem.Click

        Dim tOligo As Oligo

        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub

        tOligo = CType(Me.lvwList.SelectedItems(0).Tag, Oligo)

        If MessageBox.Show("Are you sure you want do delete " & tOligo.FullName & "?", My.Application.Info.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
            Oligo.DBDelete(frmNewMain.Conn, tOligo.OligoID)
            Me.lvwList.SelectedItems(0).Remove()
        End If

    End Sub


    Private Sub mnuTSAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSAdd.Click

        Me.mnuActionAdd_Click(Nothing, Nothing)

    End Sub

    Private Sub mnuTSEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTSEdit.Click

        Me.mnuEdit_Click(Nothing, Nothing)

    End Sub

    Private Sub ToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem1.Click

        Dim Blah As New frmOligoDNASearch

        If Blah.paDialog(Me.fOligoCollect, Me.fDNALookIn, GenDec.FormMode.ModeD) = Windows.Forms.DialogResult.OK Then

            'Flipping the mode
            Me.fMode = GenDec.FormMode.ModeD

            Me.FormLoad()

        End If


    End Sub



End Class
