Public Class frmCellLineMaint

    Private TheCellLine As CellLine
    Private fMode As GenDec.FormMode


#Region " Form Events "

    Private Sub frmCellLineMaint_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'UFS.FormLoad(Me, GenDec.INIFileName)


        If frmNewMain.CellLineCustomField1 = "" Then
            Me.lblCustomField1.Text = "[Custom 1]:"
        Else
            Me.lblCustomField1.Text = frmNewMain.CellLineCustomField1 & ":"
        End If

        If frmNewMain.CellLineCustomField2 = "" Then
            Me.lblCustomField2.Text = "[Custom 2]:"
        Else
            Me.lblCustomField2.Text = frmNewMain.CellLineCustomField2 & ":"
        End If




        If TheCellLine.CellLineID = 0 Then
            'New
            Me.Text = "New Cell Line"
            fMode = GenDec.FormMode.ModeAdd

            Me.TheCellLine.LabName = frmNewMain.CellLineLabSuffix




        Else
            'Edit
            Me.Text = "Edit CellLine"
            fMode = GenDec.FormMode.ModeEdit
            'Me.txtSuffix.Text = Thecell.YeastID

        End If

        Me.dtpRecDate.Focus()


        Me.FormLoad()


    End Sub

    Private Sub frmCellLineMaint_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'UFS.FormSave(Me, GenDec.INIFileName)

    End Sub

#End Region


#Region " Form Support "

    Private Sub FormLoad()

        With Me.TheCellLine

            'Me.txtLabName.Text = .LabName
            'Me.dtpRecDate.Value = .RecDate

            Me.txtLabName.Text = .LabName
            Me.dtpRecDate.Value = .RecDate
            Me.txtCellLineName.Text = .CellLineName
            Me.txtTissueType.Text = .TissueType
            Me.txtDonor.Text = .Donor
            Me.txtSpecies.Text = .Species
            Me.txtStorageLocation.Text = .StorageLocation
            Me.txtPrefferedMedium.Text = .PreferredMedium
            Me.txtPassageNumber.Text = .PassageNumber
            Me.txtSource.Text = .Source
            Me.txtNumberOfVials.Text = .NumberOfVials
            Me.txtModification.Text = .Modification
            Me.txtFormerName.Text = .FormerName

            Me.txtComments.Text = .Comments
            Me.txtCustomField1.Text = .CustomField1
            Me.txtCustomField2.Text = .CustomField2

            If Me.fMode = GenDec.FormMode.ModeEdit Then
                'need to display the suffix
                Me.txtSuffix.Text = TheCellLine.CellLineID
            Else
                'New so see what the next autonumber will be
                Me.txtSuffix.Text = CellLine.DBNextCellLineID(frmNewMain.Conn)
            End If

        End With


    End Sub

    Private Sub FormSave()

        With Me.TheCellLine

            .LabName = Me.txtLabName.Text
            .RecDate = Me.dtpRecDate.Value
            .Donor = Me.txtDonor.Text

            .CellLineName = Me.txtCellLineName.Text
            .TissueType = Me.txtTissueType.Text
            .Species = Me.txtSpecies.Text
            .StorageLocation = Me.txtStorageLocation.Text
            .PreferredMedium = Me.txtPrefferedMedium.Text
            .PassageNumber = Me.txtPassageNumber.Text
            .Source = Me.txtSource.Text
            .NumberOfVials = Me.txtNumberOfVials.Text
            .Modification = Me.txtModification.Text
            .FormerName = Me.txtFormerName.Text

            .Comments = Me.txtComments.Text
            .CustomField1 = Me.txtCustomField1.Text
            .CustomField2 = Me.txtCustomField2.Text

        End With



    End Sub


#End Region



    Private Function ValidateForm() As Boolean

        'Const cInvalidData As String = "Invalid Data"

        Dim tNum As Integer

        If Integer.TryParse(Me.txtNumberOfVials.Text, tNum) = False Then
            MessageBox.Show("Specify Number of Vials", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtNumberOfVials.Focus()
            Exit Function
        End If

        'If Me.txtLabName.Text = "" Then
        '    MessageBox.Show("Specify Lab Name", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
        '    Me.txtLabName.Focus()
        '    Exit Function
        'End If

        'If Me.txtFormerName.Text = "" Then
        '    MessageBox.Show("Specify Former Name", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
        '    Me.txtLabName.Focus()
        '    Exit Function
        'End If


        'Made it this far
        Return True

    End Function


    Public Function paDialog(ByRef rCellLine As CellLine) As Windows.Forms.DialogResult


        Me.TheCellLine = rCellLine

        Me.ShowDialog()

        Return Me.DialogResult


    End Function


#Region " Control Support "

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click

        If ValidateForm() = False Then Exit Sub

        Me.FormSave()

        'Saving to the database
        'TheOligo.DBSave(frmMain.Conn)


        Me.DialogResult = Windows.Forms.DialogResult.OK

        Me.Close()


    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.Close()

    End Sub


#End Region




End Class